import inspect, collections

class Not_Recursive: # Exception if recursive
    def __init__(self,f,allow_recursive=[]):
        self._f = f
        self._allow_recursive = allow_recursive + ['<module>']
    
    # Every time called, check whether other calls in the call stack; AssertionError if any    
    def __call__(self,*args, **kargs):
        calls = collections.defaultdict(int)
        for se in inspect.stack():
            calls[se.function] += 1
        recurs = {k:v for k,v in calls.items() if k not in self._allow_recursive and v != 1}
        assert recurs == {}, "Function is recursive: "+str(recurs)+' each called recursively'
#         assert all(times==1 for times in calls.values()), "Function is recursive"+str(recurs)
#         assert all(se.function != self._f.__name__ for se in inspect.stack()), "Function is recursive"
        return self._f(*args,**kargs)

class Recursive:
    def __init__(self,f,ignore_recursive=[]):
        self._f = f
        self._ignore_recursive = ignore_recursive + ['<module>','__call__']
        self._recurs = collections.defaultdict(int)
        
    def __call__(self,*args, **kargs):
        calls = collections.defaultdict(int)
        for se in inspect.stack():
            calls[se.function] += 1
        for k in set(calls)|set(self._recurs):
            self._recurs[k] = max(calls.get(k,0), self._recurs.get(k,0))
#         self._recursive_depth = max(self._recursive_depth,
#                                       sum(map((lambda se : 1 if se.function == self._f.__name__ else 0),inspect.stack())))
        return self._f(*args,**kargs)

# Works only when directly recursive; not with recursive helper function.
# For that see setting recursion limit
def check_recursive(f : Recursive, min, *args, **kargs):
    answer = f(*args,**kargs)
    recurs = {k:v for k,v in f._recurs.items() if k not in f._ignore_recursive and v != 1}
    assert  any(v >= min for k,v in recurs.items()),"Function is not recursive to depth "+str(min)
    return answer 

            
if __name__ == '__main__':
    import driver
    driver.default_file_name = 'bsc.txt'
#     driver.default_show_traceback = True
#     driver.default_show_exception = True
#     driver.default_show_exception_message = True
    print('\n\n')
    driver.driver()

#    @Not_Recursive
#     # def fact(n):
#     #     a = 1
#     #     for i in range(n):
#     #         a *= i
#     #     return a
#     
#     def fact (n):
#         if n == 0:
#             return 1
#         else:
#             return n*fact(n-1)
#         
#     print(fact(8))
#     print(fact._recursive_depth)